from logger import Logger
from typing import Dict, List, Any
import bottle
import json


class BasicService(object):
    log: Logger
    servicePath: str
    cases: Dict[str, List[Dict[str, Any]]]

    def __init__(self):
        self.log = Logger()
        self.servicePath = '/'
        self.cases = {}

    def _createResponse(self, methodName: str):
        if methodName not in self.cases:
            raise bottle.HTTPError(400, 'Метод "%s" не найден' % methodName)

        if not len(self.cases[methodName]):
            self.log.warn('В кейсах не осталось значений')
            return None

        # если в кейсе нет счётчика, то возвращаем str(response)
        if 'count' not in self.cases[methodName][0]:
            return self.cases[methodName][0].get('response')

        self.cases[methodName][0]['count'] -= 1
        response = self.cases[methodName][0].get('response')

        if self.cases[methodName][0]['count'] == 0:
            del self.cases[methodName][0]

        return response
